/******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "./dist/lib/index.js":
/*!***************************!*\
  !*** ./dist/lib/index.js ***!
  \***************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
var _typeof2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/typeof */ "./node_modules/@babel/runtime/helpers/typeof.js"));
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.object2tree = exports.array2tree = void 0;
/* eslint no-prototype-builtins: [off] */
/**
 * Maps recursively an array via an `apply` function, until the array
 * is completely mapped, or `apply` returns `false`. The structure of
 * the array should comply to:
 *
 * (1) the item at index `0` should be the *value* for a given node,
 *     which can be `null` for the root node;
 *
 * (2) the items at index `1` or higher should be arrays, representing
 *     sub-nodes (if any);
 *
 * (3) the item at index `0` of these arrays representing sub-nodes,
 *     should be the *name* of the corresponding sub-node;
 *
 * (4) the item at index `1` of these sub-node arrays, should be yet
 *     another array representing the sub-tree under the sub-node.
 *
 * Essentially, the array is a fully recursive structure, except the outer
 * most layer where the name of the node for the given path is dropped.
 *
 * @param path path of a node to map to, where `null` implies root
 * @param object object to be mapped via the `apply` function
 * @param apply function via which the array values are mapped
 * @param separator separator string between path elements
 *
 * @returns true upon a complete mapping, otherwise false
 */
var array2tree = function at2(path, array, apply) {
  var separator = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "/";
  if (path !== null && path.startsWith(separator)) {
    path = path.slice(1);
  }
  if (path !== null && path.endsWith(separator)) {
    path = path.slice(0, -1);
  }
  if (array.length > 0) {
    var value = array[0];
    if (false === apply(path, value)) {
      return false;
    }
    for (var i = 1; i < array.length; i++) {
      var node = array[i];
      if (node.length > 1) {
        var name = node[0];
        var tree = node[1];
        if (false === at2("".concat(path || "").concat(separator).concat(name), tree, apply, separator)) {
          return false;
        }
      } else {
        continue;
      }
    }
    return true;
  }
  return false;
};
exports.array2tree = array2tree;
/**
 * Maps recursively a JSON-like object via an `apply` function, until the
 * object is completely mapped or `apply` returns `false`.
 *
 * @param path path of a node to map to, where `null` implies root
 * @param object object to be mapped via the `apply` function
 * @param apply function via which the object values are mapped
 *
 * @param separator separator string between path elements
 * @param value_key default value key for node values
 *
 * @returns true upon a complete mapping, otherwise false
 */
var object2tree = function o2t(path, object, apply) {
  var separator = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "/";
  var value_key = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : "_";
  if (path !== null && path.startsWith(separator)) {
    path = path.slice(1);
  }
  if (path !== null && path.endsWith(separator)) {
    path = path.slice(0, -1);
  }
  if (object !== null) {
    if ((0, _typeof2["default"])(object) === "object") {
      for (var key in object) {
        if (object.hasOwnProperty(key)) {
          if (key === value_key) {
            if (false === apply(path, object[value_key])) {
              return false;
            }
          } else {
            if (false === o2t("".concat(path || "", "/").concat(key), object[key], apply, separator, value_key)) {
              return false;
            }
          }
        }
      }
      return true;
    } else {
      return apply(path, object) !== false;
    }
  } else {
    return apply(path, object) !== false;
  }
};
exports.object2tree = object2tree;
exports["default"] = exports.object2tree;


/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js":
/*!**********************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/interopRequireDefault.js ***!
  \**********************************************************************/
/***/ ((module) => {

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {
    "default": obj
  };
}
module.exports = _interopRequireDefault, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/typeof.js":
/*!*******************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/typeof.js ***!
  \*******************************************************/
/***/ ((module) => {

function _typeof(obj) {
  "@babel/helpers - typeof";

  return (module.exports = _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  }, module.exports.__esModule = true, module.exports["default"] = module.exports), _typeof(obj);
}
module.exports = _typeof, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	var __webpack_exports__ = __webpack_require__("./dist/lib/index.js");
/******/ 	
/******/ })()
;
//# sourceMappingURL=index.umd.js.map